/** @mainpage Grupo de Modelacin Matemtica y Computacional
 *
 * @section intro_sec Introduccin
 *
 * La presente documentacin es un esfuerzo del grupo de Modelacin Matemtica 
 * y Computacional en que se llevan a cabo actividades como el acopio, 
 * la organizacin, la documentacin y publicacin de algoritmos, mtodos, 
 * modelos, paquetes, sitios afines, etc, para el uso de investigadores y 
 * estudiantes interesados en dichas disciplinas. 
 *
 * @subsection sub1 Para que fue desarrollado el programa? 
 * El programa ha sido desarrollado con fines acadmicos y de investigacin, ms especficamente, para probar diferentes mtodos de discretizacin usados en la solucin 
 * de problemas de ecuaciones diferenciales parciales con valores en la frontera. Este trabajo es realizado por alumnos del posgrado (en ciencias de la tierra como de 
 * ciencias en computacin de la UNAM) para probar las metodologas que desarrollan en sus respectivos trabajos acadmicos. Estos programas son liberados como software
 * libre bajo la licencia GPL. 

 * @subsection sub2 Qu es el software libre? 
 * En primer lugar, un software cuyo secreto de fabricacin (el llamado "cdigo fuente", algo as como los "planos" del programa) es conocido y difundido libremente. El 
 * autor del software concede a cualquiera el derecho a usar su obra, a modificarla y a adaptarla a sus necesidades especficas. Este derecho de libre uso a veces se 
 * otorga sin restricciones (licencias tipo BSD) y otras veces con la nica condicin de que toda mejora se distribuya con las mismas condiciones de uso que tiene 
 * originalmente y por tanto siga estando libremente disponible para todo el mundo (licencias tipo copyleft, como la GPL de la Free Software Foundation). A diferencia de 
 * lo que sucede con el software propietario cuyo nico objetivo es la rentabilidad econmica y no el hacer buenas herramientas, la comunidad del software libre se 
 * empea en la bsqueda de una buena adecuacin entre las necesidades y el propio producto, esto es, busca a la vez la calidad y la eficiencia social que otorga la 
 * libertad de uso. 

 * @subsection sub3 Qu tipo de dato de punto flotante se usa en el programa? 
 * Se pueden usar double y long double, el tipo de dato se define en el archivo Definiciones.hpp al comentar o descomentar la directiva de compilacin __Double__, por 
 * omisin el tipo de dato usado es double, al ser este aceptado en todos los compiladores de C++. 

 * @section comp_sec Cmo compilo y ejecuto el programa? 
 * Primeramente hay que bajar los fuentes de cada ejemplo (en el cdigo de los ejemplos slo cambia la funcin principal Principal.cpp y el archivo Problema.cpp).
 
 * Si compila en LINUX o UNIX usar: 

 * $ g++ -O1 *.cpp -o ejemp 

 * Para ejecutar el programa ya compilado 

 * $ ./ejemp 

 * Si compila en Windows, recomendamos el uso del compilador MinGW Minimalist GNU for Windows (Compilador de linea para C, C++, Fortran, Ada, Java, Pascal, ObjC, etc, 
 *  para 32 y 64 bits) usando las mismas opciones que anteriormente se describieron. 


 * @section license_sec Licencia
 * Este programa es software libre. Puede redistribuirlo y/o modificarlo 
 * bajo los trminos de la Licencia Pblica General de GNU segn es                  
 * publicada por la Free Software Foundation, bien de la versin 2 de               
 * dicha Licencia o bien (segn su eleccin) de cualquier versin                   
 * posterior.                                                               
                                                                         
 * Este programa se distribuye con la esperanza de que sea til, pero SIN   
 * NINGUNA GARANTA, incluso sin la garanta MERCANTIL implcita o sin      
 * garantizar la CONVENIENCIA PARA UN PROPSITO PARTICULAR. Vase la        
 * Licencia Pblica General de GNU para ms detalles.                       
                                                                         
 * Debera haber recibido una copia de la Licencia Pblica General junto    
 * con este programa. Si no ha sido as, escriba a la Free Software         
 * Foundation, Inc., en 675 Mass Ave, Cambridge, MA 02139, EEUU.            
 * 
 * 
 */

